/*jslint browser: true, nomen: true, white: true */
/*!
 * responsiveCarousel
 * A responsive carousel that works in desktop browsers, ipad, iphone, and even
 * most Androids.  It uses css3 animations with a jquery animation fallback for
 * greater speed.  The code was optimized to minimize page reflows to further
 * enhance the overall speed..
 *
 * This is a jQuery UI Widget
 *
 * @version 1.7.3
 * @releaseDate 6/27/2013
 * @author Matthew Toledo
 * @url https://github.com/mrbinky3000/responsive_carousel
 * @requires jQuery, jQuery UI (only the Core and Widget Factory), modernizr (only css3 transitions test, touch test optional), hammer.js
 */
(function(e,f,u){var q=0;e.widget("ri.responsiveCarousel",{options:{arrowLeft:".arrow-left span",arrowRight:".arrow-right span",mask:".slider-mask",target:"ul",unitElement:"li",unitWidth:"inherit",responsiveUnitSize:null,onRedraw:null,ondragstart:null,ondragend:null,dragEvents:!1,easing:"linear",speed:400,slideSpeed:2500,step:-1,responsiveStep:null,onShift:null,cssAnimations:Modernizr.csstransitions,nudgeThreshold:10,infinite:!1,delta:1,dragVertical:!1,dragPreventDefault:!1,lazyload:!1},_getPrefix:function(b){for(var c=
["Moz","Webkit","Khtml","0","ms"],a=u.createElement("div"),d=b.charAt(0).toUpperCase()+b.slice(1),e="",g=c.length;-1<g;)void 0!==a.style[c[g]+d]&&(e=c[g]),g-=1;return e=a.style[b]?b.toLowerCase():"-"+e.toLowerCase()+"-"},_round:function(b){if("compute"===this.options.unitWidth||"inherit"===this.options.unitWidth||"integer"===this.options.unitWidth)b=Math.round(b/this.internal.unitWidth)*this.internal.unitWidth;return b},_animate:function(b,c,a,d){var h=this.options,g=this.internal,k=g.prefix+"transition",
l=this._round(Math.floor(b.position().left)),n=c.left,p=l+n;b.css(k,"");(function(){var a=e('<div class="redraw-'+q+'"> </div>');a.appendTo(b);a.hide();a.get(0).offsetHeight;a.show();f.setTimeout(function(){a.remove()},1)})();!0===h.infinite&&void 0!==n&&(n<l?(n=-1*g.unitWidth*(g.numUnits-g.numVisibleUnits),l===n&&(b.css("left",0),c.left=-g.unitWidth)):n>l&&0===l&&(n=-1*Math.floor(b.find(".clone:first").position().left),b.css("left",n),c.left=n+p));f.setTimeout(function(){h.cssAnimations?(b.css(k,
"left "+a/1E3+"s "+h.easing),b.css(c),f.setTimeout(function(){b.css(k,"");e.isFunction(d)&&d()},a)):b.animate(c,a,function(){e.isFunction(d)&&d()})},1)},_requestAnimationFrameShim:function(){var b=0,c=["ms","moz","webkit","o"],a;if(!f.requestAnimationFrame||!f.cancelAnimationFrame){for(a=0;a<c.length&&!f.requestAnimationFrame;a+=1)f.requestAnimationFrame=f[c[a]+"RequestAnimationFrame"],f.cancelAnimationFrame=f[c[a]+"CancelAnimationFrame"]||f[c[a]+"CancelRequestAnimationFrame"];f.requestAnimationFrame||
(f.requestAnimationFrame=function(a){var c=(new Date).getTime(),e=Math.max(0,16-(c-b)),k=f.setTimeout(function(){a(c+e)},e);b=c+e;return k});f.cancelAnimationFrame||(f.cancelAnimationFrame=function(a){clearTimeout(a)})}},_setTargetWidth:function(){var b=this.internal,c=this.options,a=e(c.unitElement),d;b.numUnits=e(c.unitElement).length;d=b.numUnits;if("individual"===c.unitWidth)for(b.targetWidth=0;d--;){var h=void 0,g=e(a[d]);g.css("width","");h=Math.ceil(g.width())+1;g.width(h);b.targetWidth+=h;
g.data("responsiveCarousel",{width:h,top:Math.floor(g.position().top),right:Math.floor(g.position().left)+g.width(),bottom:Math.floor(g.position().top)+g.height(),left:Math.floor(g.position().left)})}else b.targetWidth=b.numUnits*b.unitWidth;e(c.target).width(b.targetWidth);b.targetHeight=e(c.target).height();b.maskWidth=e(c.mask).width();b.maskHeight=e(c.mask).height()},_setArrowVisibility:function(){var b=this.options,c=this.internal,a=e(b.target),d=e(b.arrowLeft),h=e(b.arrowRight),g,k=c.maskWidth,
a=this._round(Math.floor(a.position().left)),l=c.targetWidth+a;h.length&&(!0!==b.infinite&&l<=k?(h.addClass("disabled"),!0===c.isArrowBeingClicked&&this._clearInterval(),c.arrowRightVisible=c.isArrowBeingClicked=!1):(h.removeClass("disabled"),c.arrowRightVisible=!0));d.length&&(!0!==b.infinite&&0<=a?(d.addClass("disabled"),!0===c.isArrowBeingClicked&&this._clearInterval(),c.arrowLeftVisible=c.isArrowBeingClicked=!1):(d.removeClass("disabled"),c.arrowLeftVisible=!0));"individual"!==b.unitWidth&&(c.currentSlide=
e(b.unitElement).eq([Math.abs(a/c.unitWidth)]).data("slide"),g=c.currentSlide);if(e.isFunction(b.onShift)){if("number"===typeof g)b.onShift(g)}else if(null!==b.onShift)throw Error("The onShift option must be a function or null if not in use.");},_clearInterval:function(){var b=this.internal;"number"===typeof b.timer&&(b.isArrowBeingClicked=!1,f.clearInterval(b.timer))},_doArrowBeingClicked:function(b){var c=this,a=this.internal,d=this.options,h=e(d.target),g=Math.floor(h.position().left),k,l=d.speed,
f,p,m=a.currentSlide;if(!0!==a.busy){if("individual"===d.unitWidth)if("right"===b)if("right"===a.lastArrowClicked)m<a.numUnits-1&&(m+=1,b=e(d.unitElement).eq(m).data("responsiveCarousel"),k=g-b.width,a.currentSlide=m);else for(a.lastArrowClicked="right",f=-1*g+a.maskWidth,p=a.numUnits;m<p;){b=e(d.unitElement).eq(m).data("responsiveCarousel");if(f>=b.left&&f<=b.right){k=g-(b.right-f);l=d.speed-d.speed*((f-b.left)/b.width);a.currentSlide=m;break}m+=1}else if("left"===b)if("left"===a.lastArrowClicked)0<
m&&(m-=1,b=e(d.unitElement).eq(m).data("responsiveCarousel"),k=g+b.width,a.currentSlide=m);else{if(a.lastArrowClicked="left",e(d.unitElement).eq(a.currentSlide).length)for(f=Math.abs(g);0<=m;){b=e(d.unitElement).eq(m).data("responsiveCarousel");if(f>=b.left&&f<=b.right){k=g+b.width;b.right>f&&(k-=b.right+g);l=d.speed*((f-b.left)/b.width);a.currentSlide=m;break}m-=1}}else throw Error("unknown direction");else if("left"===b)k=g+a.unitWidth;else if("right"===b)k=g-a.unitWidth;else throw Error("unknown direction");
k=this._round(k);d=a.maskWidth<a.targetWidth?a.maskWidth-a.targetWidth:0;0<k&&(k=0);k<d&&(k=d);a.busy=!0;this._animate(h,{left:k},100<=l?l:100,function(){c._setArrowVisibility("_doArrowBeingClicked");a.busy=!1})}},_setArrowEvents:function(){var b=this,c=this.options,a=this.internal,d=e(c.arrowLeft),h=e(c.arrowRight),g="",k="";d.on("click"+this.instanceId,function(a){a.preventDefault()});h.on("click"+this.instanceId,function(a){a.preventDefault()});!0===c.dragEvents?(g="mousedown"+this.instanceId+
" touchstart"+this.instanceId+" gesturestart"+this.instanceId+" gesturechange"+this.instanceId,k="mouseup"+this.instanceId+" mouseout"+this.instanceId+" mouseleave"+this.instanceId+" touchend"+this.instanceId+" touchleave"+this.instanceId+" gestureend"+this.instanceId):(g="mousedown"+this.instanceId,k="mouseup"+this.instanceId+" mouseout"+this.instanceId+" mouseleave"+this.instanceId);d.on(g,function(c){!0===a.ios6Device&&(a.busy=!1);c.preventDefault();c.stopPropagation();!1!==a.busy||d.hasClass("disabled")||
(a.isArrowBeingClicked=a.firstMouseClick=!0,a.timer=f.setInterval(function(){b._doArrowBeingClicked("left")},10),a.slideTimer&&(f.clearInterval(a.slideTimer),a.slideShowActive=!1))});h.on(g,function(d){!0===a.ios6Device&&(a.busy=!1);d.preventDefault();d.stopPropagation();!1!==a.busy||h.hasClass("disabled")||(a.isArrowBeingClicked=a.firstMouseClick=!0,a.timer=f.setInterval(function(){b._doArrowBeingClicked("right")},10),a.slideTimer&&(f.clearInterval(a.slideTimer),a.slideShowActive=!1))});e.each([d,
h],function(){e(this).on(k,function(){!0===a.isArrowBeingClicked&&b._clearInterval()})});e(f).on("scroll"+this.instanceId,function(){"individual"!==c.unitWidth&&(f.clearTimeout(a.scrollTimer),a.scrollTimer=f.setTimeout(function(){b._clearInterval()},100))});e(f).on(" resize"+this.instanceId+" onorientationchange"+this.instanceId,function(){f.clearTimeout(a.resizeTimer);a.resizeTimer=f.setTimeout(function(){b._setTargetWidth();b._clearInterval()},100)})},_setUnitWidth:function(){var b,c,a=this,d=this.internal,
h=this.options,g=e(h.target),k=e(this.element),l=e(h.unitElement+":not(.clone)"),n=l.eq(0),p,m,r,s=function(){d.unitWidth=n.width()},t=function(){d.maskWidth=e(h.mask).width();c=h.responsiveUnitSize(k,d,h);if("number"!==typeof c||1>c)throw Error("The responsiveUnitSize callback must return a whole number greater than 0");b=d.maskWidth/c;b=Math.floor(b);e(h.unitElement).css("width",b);!0===h.infinite&&(0<c&&c!==d.numVisibleUnits)&&(d.numVisibleUnits=c,g.find(".clone").remove(),l.slice(0,d.numVisibleUnits).clone(!0).addClass("clone").appendTo(g));
d.unitWidth=b;d.numVisibleUnits=c},q=function(b){e(b).one("load"+a.instanceId,function(){if(!1===g.is(":hidden")||!0===g.is(":visible"))f.clearTimeout(d.imageLoadTimer),d.imageLoadTimer=f.setTimeout(function(){e.isFunction(h.responsiveUnitSize)&&t();s();a._setTargetWidth();a._setArrowVisibility();if(e.isFunction(h.onRedraw))h.onRedraw(k,d,h)},400)})};if("inherit"===h.unitWidth)s(),g.find("img").one("load"+a.instanceId,function(){s();a._setTargetWidth();a._setArrowVisibility();if(e.isFunction(h.onRedraw))h.onRedraw(k,
d,h)});else if("individual"===h.unitWidth){if(!1===g.is(":hidden")||!0===g.is(":visible"))a._setTargetWidth(),a._setArrowVisibility();if(e.isFunction(h.onRedraw))h.onRedraw(k,d,h);g.find("img").one("load"+a.instanceId,function(){if(!1===g.is(":hidden")||!0===g.is(":visible"))f.clearTimeout(d.imageLoadTimer),d.imageLoadTimer=f.setTimeout(function(){a._setTargetWidth();a._setArrowVisibility();if(e.isFunction(h.onRedraw))h.onRedraw(k,d,h)})});e(f).on("resize"+a.instanceId,function(){var b=d.currentSlide;
clearTimeout(d.setWidthTimer);d.setWidthTimer=setTimeout(function(){var c,l,m;if(!1===g.is(":hidden")||!0===g.is(":visible"))a._setTargetWidth(),c=e(h.unitElement).eq(b).data("responsiveCarousel"),"right"===d.lastArrowClicked?c=d.maskWidth-c.right:"left"===d.lastArrowClicked&&0<b?c=-1*e(h.unitElement).eq(b-1).data("responsiveCarousel").right:(c=0,d.currentSlide=0),m=d.left+c,l=d.maskWidth-d.targetWidth,m<l&&(c=l,d.currentSlide=d.numUnits-1),0<m&&(c=0,d.currentSlide=0),g.css({left:c}),f.requestAnimationFrame(function(){a._setArrowVisibility("_setUnitWidth individual resize");
if(e.isFunction(h.onRedraw))h.onRedraw(k,d,h)})},400)})}else if("compute"===h.unitWidth){s();e.isFunction(h.responsiveUnitSize)&&(t(),s());if(e.isFunction(h.onRedraw))h.onRedraw(k,d,h);m=g.find("img");r=m.length;for(p=0;p<r;++p)q(m[p]);e(f).on("resize"+a.instanceId,function(){var b=d.currentSlide;f.clearTimeout(d.setWidthTimer);if(!1===g.is(":hidden")||!0===g.is(":visible"))d.setWidthTimer=setTimeout(function(){var c,f=-1*d.numUnits*d.unitWidth+d.maskWidth;e.isFunction(h.responsiveUnitSize)&&(t(),
s());s();a._setTargetWidth();c=-1*b*d.unitWidth;c<f&&(c=d.maskWidth-d.targetWidth);g.css({left:c});a._setArrowVisibility();if(e.isFunction(h.onRedraw))h.onRedraw(k,d,h)},500)})}else d.unitWidth=h.unitWidth},_dragEvents:function(){var b=this,c=this.options,a=this.internal,d=e(c.target),h=e(c.mask),g,h=new Hammer(h.get(0),{prevent_default:c.dragPreventDefault,css_hacks:!0,drag:!0,drag_vertical:c.dragVertical,drag_horizontal:!0,drag_min_distance:0,swipe:!1,transform:!1,tap:!1,tap_double:!1,hold:!1}),
k={};a.touchObject=h;h.ondragstart=function(){b.stopSlideShow();f.cancelAnimationFrame(a.dragTimer);"individual"!==c.unitWidth&&(g=-1*a.unitWidth*(a.numUnits-a.numVisibleUnits));if(!0===a.isArrowBeingClicked||!0===a.busy)return{};a.busy=!0===a.ios6Device?!1:!0;k={top:parseInt(d.css("top"),10),left:parseInt(d.css("left"),10)};k.time=(new Date).getTime();a.scrollStart=k;if(e.isFunction(c.ondragstart))c.ondragstart(c,a)};h.ondrag=function(b){a.dragTimer=f.requestAnimationFrame(function(){var e=c.delta,
h=b.direction,f,r;if(!0!==a.isArrowBeingClicked){if("up"===h||"left"===h)b.distance*=-1;f=k.left+b.distance*e;r=Math.abs(a.scrollStart.left-f);"individual"===c.unitWidth?r>c.nudgeThreshold&&(a.nudgeDirection="up"===b.direction||"left"===b.direction?"left":"right"):a.nudgeDirection=r>c.nudgeThreshold&&r<a.unitWidth/2?"up"===h||"left"===h?"left":"right":r<=c.nudgeThreshold?"abort":null;!0===c.infinite&&(f<=g&&(f=b.distance*e,a.scrollStart.left=0),0<=f&&(f=g+b.distance*e,a.scrollStart.left=g));a.left=
f;d.css("left",f)}})};h.ondragend=function(){f.cancelAnimationFrame(a.dragTimer);d.stop(!0,!1);f.requestAnimationFrame(function(){b._animate(d,{left:b.computeAdjust(d)},c.speed,function(){b._setArrowVisibility();a.busy=!1;if(e.isFunction(c.ondragend))c.ondragend(c,a)})})}},_create:function(){q+=1;var b=this.options,c=e(this.element),a=e(b.target);this.instanceId=".carousel_"+q.toString(10);this.internal={busy:!1,currentSlide:0,left:0,targetWidth:0,targetHeight:0,maskWidth:0,maskHeight:0,unitWidth:0,
targetBackupCopy:null,isArrowBeingClicked:!1,lastArrowClicked:null,arrowLeftVisible:!0,arrowRightVisible:!0,targetLeft:0,timer:null,dragTimer:null,dragEndTimer:null,scrollTimer:null,resizeTimer:null,firstMouseClick:!1,prefix:null,slideShowActive:!1,slideTimer:null,slideBumped:!1,nudgeDirection:null,infinite:!1,numUnits:null,numVisibleUnits:null,scrollStart:0,touchObject:null,setWidthTimer:null,lazyloaded:!1,ios6Device:!1};this.internal.backup=a.clone(!0,!0);this.options.cssAnimations&&(this.internal.prefix=
this._getPrefix("transition"));/(iPhone|iPod|iPad)/i.test(navigator.userAgent)&&/OS 6_/i.test(navigator.userAgent)&&(this.internal.ios6Device=!0);this._requestAnimationFrameShim();a.css({position:"relative",left:0});a.addClass("instance-"+q);e(b.unitElement).each(function(a){e(this).attr({"data-slide":a})});!0===b.dragEvents&&this._dragEvents();this._setArrowEvents();!0===b.lazyload&&e(b.target).find("img.lazy-slider").lazyload({effect:"fadeIn",skip_invisible:!1});if(!0===a.is(":visible")||!1===a.is(":hidden"))this._setUnitWidth(),
this._setTargetWidth(),this._setArrowVisibility(),!0===b.lazyload&&this._lazyLoad();if(e.isFunction(b.onRedraw))b.onRedraw(c,this.internal,b)},_lazyLoad:function(){function b(){var a,b=e(g.unitElement);for(k=d.currentSlide;k<l;k+=1)a=b.eq(k),a.length&&a.find('img.lazy-slider:not([loaded="true"])').each(function(){e(this).trigger("appear")})}function c(){e(g.target).find('img.lazy-slider:not([loaded="true"])').each(function(){e(this).trigger("appear")})}function a(){var a=e(g.target).offset().top,
b=e(f).scrollTop()+e(f).height()+600,d=!1;a<b&&(c(),d=!0);return d}var d=this.internal,h=this.instanceId,g=this.options,k,l=d.currentSlide+2*d.numVisibleUnits;if(!0===e.browser.msie&&"8."===e.browser.version.substring(0,2))c();else if(!1===d.lazyloaded){b();e(f).on("load",function(){b()});if(!0===g.dragEvents){if(!1===a())e(f).on("scroll.tempevent"+h,function(){!0===a()&&e(f).unbind("scroll.tempevent"+h)})}else e.each([e(g.target),e(g.arrowLeft),e(g.arrowRight)],function(){var a=this;a.on("mouseover.tempevent",
function(){c();a.unbind(".tempevent")})});d.lazyloaded=!0}},redraw:function(){var b=this.internal,c=this.options,a=e(this.element);if(e(c.target).is(":visible")||e(c.target).not(":hidden")){void 0===this.unitWidth&&this._setUnitWidth();this._setTargetWidth();this._setArrowVisibility();if(e.isFunction(this.options.onRedraw))this.options.onRedraw(a,b,c);!0===c.lazyload&&this._lazyLoad()}},getCurrentSlide:function(){return this.internal.currentSlide},goToSlide:function(b,c){var a=this,d=this.internal,
h=this.options,g=e(h.target),f;c=void 0!==c?c:!0;g.not(":hidden")&&(void 0===this.unitWidth&&this._setUnitWidth(),f="individual"===h.unitWidth?e(h.unitElement).eq(b).data("responsiveCarousel").left:-1*b*d.unitWidth,d.busy=!0,!0===c?this._animate(g,{left:f},h.speed,function(){d.busy=!1;a._setArrowVisibility("goto slide")}):g.css("left",f))},toggleSlideShow:function(){!1===this.internal.slideShowActive?this.startSlideShow():this.stopSlideShow()},_step:function(b){var c=this,a=this.internal,d=this.options,
h=e(d.target),g=a.maskWidth,f=this._round(Math.floor(h.position().left)),l=f+b*a.unitWidth,n=f+a.targetWidth;b=n+b*a.unitWidth;var p=l;!1===a.slideBumped?!1===d.infinite&&(b<=g&&(p=l+g-b,a.slideBumped="left"),0<=l&&(a.slideBumped="right",p=0)):("left"===a.slideBumped&&(p=0),"right"===a.slideBumped&&(p=f+g-n),a.slideBumped=!1);a.busy=!0;this._animate(h,{left:p},d.speed,function(){a.busy=!1;c._setArrowVisibility("_step")})},startSlideShow:function(){var b=this,c=this.internal,a=this.options;!1===c.slideShowActive&&
(c.slideShowActive=!0,c.slideTimer=f.setInterval(function(){b._step(a.step)},a.slideSpeed))},stopSlideShow:function(){var b=this.internal;!0===b.slideShowActive&&(b.slideShowActive=!1,f.clearInterval(b.slideTimer))},_destroy:function(){var b=e(this.options.target),c=e(this.options.mask);f.clearTimeout(this.internal.setWidthTimer);f.clearInterval(this.internal.slideTimer);f.clearTimeout(this.internal.scrollTimer);f.clearTimeout(this.internal.resizeTimer);f.cancelAnimationFrame(this.internal.dragTimer);
e(f).unbind(this.instanceId);e(u).unbind(this.instanceId);e(this.options.arrowLeft).unbind(this.instanceId);e(this.options.arrowRight).unbind(this.instanceId);b.removeClass("instance-"+q);b.find("img").unbind(this.instanceId);null!==this.internal.touchObject&&this.internal.touchObject.destroy();c.css({"-webkit-user-select":"","-webkit-user-drag":"","-webkit-tap-highlight-color":""});b.replaceWith(this.internal.backup)},computeAdjust:function(b){function c(){var a,b,c,g=d.currentSlide,n=e(h.unitElement);
a=-1*f+d.maskWidth;for(b=d.numUnits;g<b;){c=n.eq(g).data("responsiveCarousel");if(a>=c.left&&a<=c.right){l=f-(c.right-a);d.currentSlide=g;return}g+=1}l=f}function a(){var a,b,c=d.currentSlide,g=e(h.unitElement);for(a=Math.abs(f);0<=c;){b=g.eq(c).data("responsiveCarousel");if(a>=b.left&&a<=b.right){l=f+b.width;b.right>a&&(l-=b.right+f);d.currentSlide=c;return}c-=1}l=f}var d=this.internal,h=this.options,g=d.scrollStart.left,f=b.position().left;b=d.maskWidth;var l=0,n=d.nudgeDirection,p=d.unitWidth;
"individual"===h.unitWidth?null!==n&&("left"===n&&c(),"right"===n&&a(),"abort"===n&&(l=f),f=l,d.nudgeDirection=null):null!==n&&("left"===n&&(l=g-p),"right"===n&&(l=g+p),"abort"===n&&(l=f),f=l,d.nudgeDirection=null);g=f+d.targetWidth;g<b&&(f=l=f+b-g);0<f&&(f=l=0);"individual"!==h.unitWidth&&(l=this._round(f));!0===isNaN(l)&&(l=0);return l},getNumVisibleUnits:function(){return this.internal.numVisibleUnits}})})(jQuery,window,document);
